<?php
namespace Teknisa\SUP\Modules\Cadastros\Controllers; 

use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\Controller;
use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DTO\Response\Notification;
use Teknisa\SUP\Modules\Cadastros\Services\AprovadorService;

class AprovadorRelacionadoController extends \Teknisa\GER\Controllers\TeknisaCrud 
{
    
    protected $dataSourceName = "aprovador_relacionado";
    
    public function __construct($crudService, ParameterBag $parameterBag, $connection, AprovadorService $service) {
        $this->crudService = $crudService;
        $this->parameterBag = $parameterBag;
        $this->connection = $connection;
        $this->service      = $service;
    }
    
        public function saveAprovadorRelacionado(DTO\Request\Row $request, DTO\Response $response){
            $row = $request->getRow();
            
            $newCode = $this->service->generateCode('ALCADAGERFILI');
            $newCode = substr($newCode, -3);
            
            $params = array();
            $params['P_NRALCADAGEROPER'] = $newCode;
            $params['P_NRCONFIGALCADA'] = $row['NRCONFIGALCADA'];
            $params['P_CDFILIAL'] = $row['CDFILIAL'];
            $params['P_CDOPERADOR'] = $row['CDOPERADOR'];
            $params['P_CDOPERRELACAP'] = $row['CDOPERRELACAP'];
            $params['P_DTINCLUSAO']   = $row['DTINCLUSAO'];
        
            try {
            $sql = "INSERT INTO ALCADAGEROPER (NRALCADAGEROPER, NRCONFIGALCADA, CDFILIAL, CDOPERADOR, CDOPERRELACAP, DTINCLUSAO) VALUES (:P_NRALCADAGEROPER, :P_NRCONFIGALCADA, :P_CDFILIAL, :P_CDOPERADOR, :P_CDOPERRELACAP, :P_DTINCLUSAO)";
                $std = $this->connection->prepare($sql);
                $std->execute($params);
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function remove(DTO\Request\Row $request, DTO\Response $response)
    {
        $row = $request->getRow();
            $params                     = array();
            $params['P_NRCONFIGALCADA'] = $row['NRCONFIGALCADA']; 
            
            try {
                $sql = "DELETE FROM ALCADAGEROPER WHERE NRCONFIGALCADA = :P_NRCONFIGALCADA";
                $std = $this->connection->prepare($sql);
                $std->execute($params);
                
                $sql = "DELETE FROM ALCADAGERFILI WHERE NRCONFIGALCADA = :P_NRCONFIGALCADA";
                $std = $this->connection->prepare($sql);
                $std->execute($params);
                
                $sql = "DELETE FROM FILIALCADA WHERE NRCONFIGALCADA = :P_NRCONFIGALCADA";
                $std = $this->connection->prepare($sql);
                $std->execute($params);
                
                $sql = "DELETE FROM CONFIGALCADA WHERE NRCONFIGALCADA = :P_NRCONFIGALCADA";
                $std = $this->connection->prepare($sql);
                $std->execute($params);
            }
            catch (Exception $e) {
                throw $e;
            }
    }
}
